package com.yuandian.dataflow.grpc;

import com.mongodb.MongoClient;
import com.mongodb.MongoCredential;
import com.mongodb.ServerAddress;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import org.bson.Document;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;

public class MongodbTest {

    public static <T> void insertMsgToMongoDB(T obj) {
        try {
            ServerAddress serverAddress = new ServerAddress("192.168.1.113", 27017);
            List<ServerAddress> addrs = new ArrayList<>();
            addrs.add(serverAddress);

            MongoCredential credential = MongoCredential.createScramSha1Credential("yd-rw", "admin", "yuandian123".toCharArray());
            List<MongoCredential> credentials = new ArrayList<>();
            credentials.add(credential);

            MongoClient mongoClient = new MongoClient(addrs, credentials);

            MongoDatabase db = mongoClient.getDatabase("yd-base");

            // todo 修改名字
            MongoCollection<Document> collection = db.getCollection("lxy-test");

            collection.insertOne(obj2Doc(obj));

            System.err.println("insert success");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static <T> Document obj2Doc(T obj) throws Exception {
        Document doc = new Document();
        Field[] fields = obj.getClass().getDeclaredFields();
        for (Field field : fields) {
            String varName = field.getName();
            boolean accessFlag = field.isAccessible();
            if (!accessFlag) {
                field.setAccessible(true);
            }
            Object param = field.get(obj);
            if (param == null) {
                continue;
            } else if (param instanceof Integer) {
                int value = ((Integer) param).intValue();
                doc.put(varName, value);
            } else if (param instanceof String) {
                String value = (String) param;
                doc.put(varName, value);
            } else if (param instanceof Double) {
                double value = ((Double) param).doubleValue();
                doc.put(varName, value);
            } else if (param instanceof Float) {
                float value = ((Float) param).floatValue();
                doc.put(varName, value);
            } else if (param instanceof Long) {
                long value = ((Long) param).longValue();
                doc.put(varName, value);
            } else if (param instanceof Boolean) {
                boolean value = ((Boolean) param).booleanValue();
                doc.put(varName, value);
            }
            field.setAccessible(accessFlag);
        }
        return doc;
    }

    public static <T> T doc2Obj(Document doc, Class<T> clazz) throws Exception {
        T obj = clazz.newInstance();
        for (String key : doc.keySet()) {
            Field field = clazz.getDeclaredField(key);
            field.setAccessible(true);
            field.set(obj, doc.get(key));
        }
        return obj;
    }
}
